init:

    $ library.script_version = (5, 6, 0)

    $ theme.roundrect(
        mm_root="bg/mainmenu.png",
        gm_root="#000",
        )

    $ config.developer = False

    $ config.window_title = "Broken Hearted"
        
    $ config.layers.insert(0, "subbackground")
    $ config.layers.insert(2, "clipped")
    $ config.layer_clipping["clipped"] = (0, 30, 800, 420)

    $ style.window.clear()
    $ style.window.background = "#000d"
    $ style.window.yminimum = 150
    $ style.window.xfill = True
    $ style.window.yalign = 1.0
    $ style.window.xpadding = 10
    $ style.window.top_padding = 4

    $ style.say_vbox.box_spacing = 4

    $ style.default.color = "#ccc"
    $ style.say_dialogue.color = "#dd8"
    $ style.say_label.color = "#dd8"

    $ style.skip_indicator.ypos = 14
    $ style.skip_indicator.yanchor = 0.5
    $ style.skip_indicator.xpos = 210

    $ config.font_replacement_map["DejaVuSans.ttf", True, False] = ("DejaVuSans-Bold.ttf", False, False)
    
    $ style.file_picker_text.size = 14

    $ style.mm_menu_window.xalign = 0.5
    $ style.gm_nav_window.xalign = 0.5

    $ library.enter_transition = dissolve
    $ library.exit_transition = dissolve

    $ library.has_sound = False

    $ _remove_preference('After Choices')

    $ _window_during_transitions = True

    # Define a subclass of Character to work around a non-manifesting
    # bug in image prediction.
    python:
        class MyCharacter(Character):

            def __init__(self, name, **properties):
                name = name.title()
                name = name.replace(" On ", " on ")
                name = name.replace(" Over ", " over ")
                name = name.replace(" The ", " the ")
                name = name.replace("Mta ", "MTA ")

                properties.setdefault('what_prefix', '"')
                properties.setdefault('what_suffix', '"')
                properties.setdefault('what_rest_indent', 9)
                
                Character.__init__(self, name, **properties)

            def predict(self, what):
                return [ ]
            
    
    $ artie = MyCharacter('ARTIE', color='#fcb937', what_color='#feedcc')
    $ schoolclass = MyCharacter('CLASS')
    $ detective_hernandez = MyCharacter('DETECTIVE HERNANDEZ')
    $ elizabeth = MyCharacter('ELIZABETH', color='#e3cc07', what_color='#fdf8cd')
    $ girl = MyCharacter('GIRL')
    $ headline = MyCharacter('HEADLINE')
    $ heather = MyCharacter('HEATHER', color='#f57483', what_color='#fbcfd4')
    $ card = MyCharacter(' ', who_suffix="", color='#f57483', what_color='#fbcfd4')
    $ hot_dog = MyCharacter('HOT DOG', color='#5ee02a', what_color='#ddf8d2')
    $ jack = MyCharacter('JACK')
    $ john_mccaffery = MyCharacter('JOHN MCCAFFERY')
    $ lady = MyCharacter('LADY')
    $ lick = MyCharacter('LICK', color='#c88532', what_color='#f4e7d6')
    $ lily = MyCharacter('LILY', color='#fafbce', what_color='#fafbcf')
    $ man = MyCharacter('MAN')
    $ mary = MyCharacter('MARY')
    $ me = MyCharacter('ME', color="#59a6fc", what_color='#cce4fe')
    $ mta_employee = MyCharacter('MTA EMPLOYEE')
    $ nurse = MyCharacter('NURSE') 
    $ nurse_betty = MyCharacter('NURSE BETTY', color='#da8ed5', what_color='#f2d8f0')
    $ officer = MyCharacter('OFFICER')
    $ police_officer = MyCharacter('POLICE OFFICER')
    $ radio = MyCharacter('RADIO')
    $ student_a = MyCharacter('STUDENT A')
    $ student_b = MyCharacter('STUDENT B')
    $ teacher = MyCharacter('TEACHER')
    $ television = MyCharacter('TELEVISION')
    $ voice_on_the_phone = MyCharacter('VOICE ON THE PHONE')
    $ voice_over_the_phone = MyCharacter('VOICE OVER THE PHONE')
    $ woman = MyCharacter('WOMAN')

    $ narrator = MyCharacter(" ",
                             what_prefix="",
                             what_suffix="",
                             who_suffix="",
                             what_rest_indent=0,
                             what_color='#cce4fe')

    $ click_to_advance = MyCharacter(" ",
                                     who_suffix="",
                                     what_prefix="",
                                     what_suffix="",
                                     what_minwidth=780,
                                     what_textalign=0.5,
                                     what_size=16)
    


    # Background images.

    image subbackground = Solid("#000")

    $ bgpos = dict(ypos=30, yanchor=0)

    image bg title = Image("bg/mainmenu.png")

    image bg apartment = Image("bg/r0731.jpg", **bgpos)
    image bg apartment building = Image("bg/r1382.jpg", **bgpos)
    image bg bar = Image("bg/r561921_85529631.jpg", **bgpos)
    image bg battery park 1 = Image("bg/r1160.jpg", **bgpos)
    image bg battery park 2 = Image("bg/r0339.jpg", **bgpos)
    image bg beyond the horizon = Image("bg/027r.jpg", **bgpos)
    image bg burger joint = Image("bg/rCOSI__5_.jpg", **bgpos)
    image bg cafeteria = Image("bg/r240407_1273.jpg", **bgpos)
    image bg canal street station = Image("bg/r1354.jpg", **bgpos)
    image bg cemetery 1 = Image("bg/r0474.jpg", **bgpos)
    image bg cemetery 2 = Image("bg/r0486.jpg", **bgpos)
    image bg centre street = Image("bg/r0848.jpg", **bgpos)
    image bg chamber street = Image("bg/0879.jpg", **bgpos)
    image bg chamber street station = Image("bg/r0138.jpg", **bgpos)
    image bg city hall = Image("bg/r0896.jpg", **bgpos)
    image bg city hall station = Image("bg/r0885.jpg", **bgpos)
    image bg classroom = Image("bg/r5821_8352.jpg", **bgpos)
    image bg cloud of smoke = Image("bg/rSmurfit_Stone_042.jpg", **bgpos)
    image bg cloudy sky = Image("bg/r0987.jpg", **bgpos)
    image bg cloudy sky 2 = Image("bg/r0982.jpg", **bgpos)
    image bg cloudy sky 3 = Image("bg/r0990.jpg", **bgpos)
    image bg crushed car = Image("bg/023r.jpg", **bgpos)
    image bg crushed con ed truck = Image("bg/025r.jpg", **bgpos)
    image bg crushed nypd truck = Image("bg/016r.jpg", **bgpos)
    image bg elementary school = Image("bg/r1262.jpg", **bgpos)
    image bg funeral home = Image("bg/r1774.jpg", **bgpos)
    image bg hallway = Image("bg/r347098_4763.jpg", **bgpos)
    image bg hallway dark = Image("bg/rdark347098_4763.jpg", **bgpos)
    image bg high school 1 = Image("bg/r1184.jpg", **bgpos)
    image bg high school 2 = Image("bg/r1190.jpg", **bgpos)
    image bg high school 3 = Image("bg/r1089.jpg", **bgpos)
    image bg high school 4 = Image("bg/r1081.jpg", **bgpos)
    image bg high school 5 = Image("bg/r1127.jpg", **bgpos)
    image bg holding hands = Image("bg/holding_hands.jpg", **bgpos)
    image bg kitchen = Image("bg/r0738.jpg", **bgpos)
    image bg intermediate school = Image("bg/r1336.jpg", **bgpos)
    image bg intermediate school dark = Image("bg/rdark1336.jpg", **bgpos)
    image bg intermediate school 2 = Image("bg/r1331.jpg", **bgpos)
    image bg intermediate school 3 = Image("bg/r1324.jpg", **bgpos)
    image bg lobby = Image("bg/r1319.jpg", **bgpos)
    image bg msg = Image("bg/r1657.jpg", **bgpos)
    image bg nurse office = Image("bg/rPatient_Room.jpg", **bgpos)
    image bg office = Image("bg/r11326425991.jpg", **bgpos)
    image bg penn station = Image("bg/r1677.jpg", **bgpos)
    image bg playground = Image("bg/r1284.jpg", **bgpos)
    image bg queens apartment = Image("bg/rCIMG0090.jpg", **bgpos)
    image bg queens building = Image("bg/r1350.jpg", **bgpos)
    image bg queens street = Image("bg/r1250.jpg", **bgpos)
    image bg queens street 2 = Image("bg/r1272.jpg", **bgpos)
    image bg riverdale = Image("bg/rRiverdale_train_station_800.jpg", **bgpos)
    image bg steakhouse = Image("bg/r111553157237.jpg", **bgpos)
    image bg supermarket = Image("bg/r114047766932.jpg", **bgpos)
    # image bg tribute in light = Image("bg/r02tributeoflightauto_.jpg", **bgpos)
    image bg union square 1 = Image("bg/03r.jpg", **bgpos)
    image bg union square 2 = Image("bg/05r.jpg", **bgpos)
    image bg union square 3 = Image("bg/04r.jpg", **bgpos)
    image bg union square station = Image("bg/r1450.jpg", **bgpos)
    image bg union square subway entrance = Image("bg/r1420.jpg", **bgpos)
    image bg weisman home = Image("bg/rJGS_BrickBungalow.jpg", **bgpos)
    image bg weisman living room = Image("bg/r477948_55003498.jpg", **bgpos)
    image bg west side = Image("bg/r1200.jpg", **bgpos)
    image bg 7 train = Image("bg/r1473.jpg", **bgpos)
    image bg 7 train station = Image("bg/r1468.jpg", **bgpos)
    image bg living_room = Image("bg/r0736.jpg", **bgpos)

    image bg tribute in light = "bg/tribute.jpg"
    image bg tribute cropped = im.Crop("bg/tribute.jpg", 0, 755, 800, 420)
    image bg tribute cropped2 = im.Crop("bg/tribute.jpg", 0, 700, 800, 420)


    image artie happy = "char/artie-smile.png"
    image artie neutral = "char/artie-neutral.png"

    image elizabeth happy = "char/mrsweisman.png"

    image heather adult angry = "char/heatherageadult-angry.png"
    image heather adult happy = "char/heatherageadult-happy.png"

    image heather age 12 angry = "char/heather12-angry.png"
    image heather age 12 happy = "char/heather12-happy.png"
    image heather age 12 neutral = "char/heather12-neutral.png"
    image heather age 12 scared = "char/heather12-scared.png"
    image heather age 12 rolleyes = "char/heather12-rolleyes.png"

    image heather age 13 angry = "char/heathermiddle-angry.png"
    image heather age 13 happy = "char/heathermiddle-happy.png"
    image heather age 13 neutral = "char/heathermiddle-neutral.png"
    image heather age 13 scared = "char/heathermiddle-scared.png"
    image heather age 13 rolleyes = "char/heathermiddle-rolleyes.png"

    image heather highschool angry = "char/heatherhighschool-angry.png"
    image heather highschool happy = "char/heatherhighschool-happy.png"
    image heather highschool neutral = "char/heatherhighschool-neutral.png"
    image heather highschool scared = "char/heatherhighschool-scared.png"

    image hotdog adult happy = "char/hotdog-adult.png"
    image hotdog age 12 neutral = "char/hotdog-young.png"
    image hotdog age 13 neutral = "char/hotdog-young.png"

    image lick adult angry = "char/lick-adult-angry.png"
    image lick adult neutral = "char/lick-adult-neutral.png"
    image lick adult mischievous = "char/lick-adult-neutral.png"

    image lick age 12 neutral = "char/lick-age12.png"

    image lick age 13 angry = "char/lick-age13-angry.png"
    image lick age 13 mischievous = "char/lick-age13-neutral.png"
    image lick age 13 neutral = "char/lick-age13-neutral.png"
    image lick age 13 scared = "char/lick-age13-scared.png"

    image lily happy = "char/lily-happy.png"
    image lily shy = "char/lily-shy.png"

    image nurse betty neutral = "char/betty.png"
    
init:

    python:
        
        game_time = ""
  
        def time(game_time, **kwargs):
            store.game_time = game_time

        def chapter(name, **kwargs):

            name = name.title()
            name = name.replace(" The ", " the ")
            name = name.replace(" With ", " with ")
            name = name.replace(" For ", " for ")
            name = name.replace(" To ", " to ")
            name = name.replace(" Of ", " of ")
            name = name.replace(" A ", " a ")
            name = name.replace("'S", "'s")
            name = name.replace(" In ", " in ")

            if name[-1] == ".":
                name = name[:-1]

            store.save_name = name.replace("Chapter", "Ch")

            renpy.with(fade)
            

        def draw_overlay():

            # Only show the navigation and time if we have a time
            # set. It just happens to be the case that the two match.
            if not store.game_time:
                return
            
            ui.text(store.game_time,
                    xpos=800 - 4,
                    xanchor=1.0,
                    ypos=3,
                    yanchor=0,
                    color="#dd8")

            # Button menus.

            # to save typing
            ccinc = renpy.curried_call_in_new_context

            def bgmbutton(name, target):
                ui.button(clicked=ccinc(target),
                          background=RoundRect("#111", 6),
                          hover_background=RoundRect((0, 60, 120, 255), 6),
                          xminimum = 50,
                          xminimum = 0)

                ui.text(name,
                        size=16,
                        color="#555",
                        hover_color=(200, 255, 255, 255),
                        )

            ui.hbox(xpos=4, xanchor=0, ypos=14, yanchor=0.5)
            bgmbutton("Save", "_game_menu_save")
            bgmbutton("Load", "_game_menu_load")
            bgmbutton("Prefs", "_game_menu_preferences")
            ui.close()

        config.overlay_functions.append(draw_overlay)

init:
    python hide:

        # Monkeypatch, to fix bug in clipping.

        def is_fullscreen(*args):
            return False

        renpy.display.render.is_fullscreen = is_fullscreen


init:
    python:
        def credit(title, body, effect=fade, delay=6.0, x=0.5):

            ui.window()
            ui.vbox(10, xalign=x)

            if title:
                ui.text(title,
                        xalign=0.5,
                        textalign=0.5, 
                        color="#cce4fe",
                        size = 24)

            else:
                ui.text(' ', size=24)

            ui.text(body,
                    xalign=0.5,
                    textalign=0.5,
                    size=24)


            ui.close()

            renpy.transition(effect)

            if delay:
                ui.pausebehavior(delay)

            ui.saybehavior()
            ui.interact()
            
label credits:

    time ""

    scene black
    with dissolve

    scene bg title

    $ credit(None, 'A Rest in Peace Production')

    scene bg kitchen
    show heather adult happy at right

    $ credit('Writer/Director', 'Antony "Puppychow" Chow', x=0.25)

    scene bg playground
    show lick age 13 neutral at left

    $ credit('Character Artist', 'Greatkazooman', x=0.75)

    scene bg high school 1 
    show hotdog age 13 neutral at right

    $ credit('Music', 'Matthew E. Prindiville', x=0.25)

    scene bg weisman home
    show artie happy at Position(xanchor=0.5, xpos=0.15)
    show elizabeth happy at Position(xanchor=0.5, xpos=0.45)
    show lily happy at Position(xanchor=0.5, xpos=0.30)

    $ credit('Programmer/Editor', 'PyTom', x=0.75)

    scene bg nurse office
    show nurse betty neutral at right

    $ credit('Proofreader', 'Blue Lemma', x=0.25)

    scene bg queens street
    
    $ credit('Original Backgrounds', 'Puppychow')

    scene bg burger joint

    $ credit('Stock Backgrounds', 'Jorge Dandliker (Zaphod1974)\nKelle Blount (kblount)\nKeith Syvinski (LeoSynapse)')

    scene bg classroom

    $ credit('Stock Backgrounds', 'Pilost\nKenn Kiser (click)\nNeil Gould (ngould)')

    scene bg queens apartment

    $ credit('Stock Backgrounds', 'Ana Amaral (ana_carolz)\nMalinda Welte (sideshowmom)\nAlphazeichen')

    scene bg steakhouse

    $ credit('Stock Backgrounds', 'Anthony22\nEmily Roesly (mensatic)\nMichael Connors (mconnors)')

    scene bg weisman living room

    $ credit('Stock Backgrounds', 'Gracey Stinson (gracey)\nJason Boutsayaphat (bouts)\nUnited States Coast Guard')

    scene bg riverdale

    $ credit(None, "Made with the Ren'Py Visual Novel Engine.")

    scene bg tribute cropped2 at Position(**bgpos)

    $ credit(None, 'Dedicated to those who had their lives taken on 9/11,', fade, 4.0)

    python hide:
        music = [ 'music/back_home_again.ogg',
                  'music/buggy.ogg',
                  'music/deadly_christmas.ogg',
                  'music/denial.ogg',
                  'music/funerals.ogg',
                  'music/finally_home.ogg',
                  'music/interlude.ogg',
                  'music/intro.ogg',
                  'music/leading_the_way.ogg',
                  'music/reunion_holding_hands.ogg',
                  'music/sophomore_year.ogg',
                  'music/valentines_visit.ogg' ]

        renpy.random.shuffle(music)
        renpy.music.queue(music)

    $ credit(None, 'Dedicated to those who had their lives taken on 9/11,\nand to their families and friends that survived.', dissolve, None)

    scene black
    with dissolve

    return
